; Snake 512b version
; by Tognon Stefano
; (C) 2001 Ice Team
; version 1.00

; Well, I like this competition!!!
; This is my first game for C64
; It can look like a 1982 game :((((

 ;=================================
 ; PRG start address
 ;=================================
 .byte $01,$08

 ;=================================
 ; BASIC startup program
 ;=================================
 .byte $0b,$08,$e8,$03,$9e,"2061",0,0,0

.org 2061

RED       = 28
GREEN     = 30
BLUE      = 31
L_RIGTH   = 39        ; rigth limit of the area
N_GROWN   = 4         ; rate of snake grown
SC_BORDER = 214       ; simbol of the border for char
SC_SNAKE  = 166       ; simbol of the snake body for char
SC_HEAD   = 113       ; simbol of snake head
SC_APPLE  = 115
SP_BORDER = 86        ; simbol of border for poke
SP_SNAKE  = 102
SP_APPLE  = 83        ; simbol of apple for poke
SPEED     = $8        ; speed of snake
N_APPLE   = 8         ; initial number of apple + 1

MAX_APPLE  = $B1      ; mux number of apple (decresing while in the game)
SX_START   = $B2      ; address to the start of snake positions x
SX_END     = $B4      ; address to the end of snake positions x
SY_START   = $B6      ; address to the start of snake positions y
SY_END     = $B8      ; address to the end of snake positions y
DIRECTION  = $BA      ; direction of the snake: 1 up, 2 dn, 4 sx, 8 dx
APPLE      = $BB      ; number of apple currently in the screen
TIMER      = $BC      ; timer for delay
TEMP       = $BD
GO         = $BE      ; go flag (1=go)
GROWN      = $BF      ; grown of the snake

SET_COOR   = $E50C    ; set x/y coord
PUT_CHAR   = $E716    ; put a char in the screen
LINE       = $E9F0    ; calculate current line address
SCREEN     = $E544    ; clean the screen

; init (called only one time)
      sei
      lda  #<irqR
      sta  $0314
      lda  #>irqR
      sta  $0315
      cli

      ldx  #$00
      stx  53280
      inx
      stx  53281

MainLoop:                         ; start/restart the game

; build the perimether
;clear the screen area with the snake
;      ldy  #24
;loopTy:
;      ldx  #L_RIGTH
;loopTx:
;      jsr  SET_COOR               ; set x/y coord
;      lda  #32
;      jsr  PUT_CHAR               ; put a char
;      dex
;      bpl  loopTx
;      dey
;      bpl  loopTy

       lda  #BLUE
       jsr  PUT_CHAR               ; perimether is blue
       jsr  SCREEN                 ; clear the screen

; make the left vertical line
      ldy  #00
loopL:
      ldx  #24
loopLv:
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_BORDER
      jsr  PUT_CHAR               ; put a char
      dex
      bpl  loopLv

; make the rigth vertical line
      cpy  #00
      bne  nextL
      ldy  #L_RIGTH
      jmp  loopL

; top line in this format: #######
nextL:
      ldx  #L_RIGTH
      lda  #SP_BORDER
loopT1:
      sta  1024,x
      dex
      bpl  loopT1

;bottom line
      ldx  #L_RIGTH
loopT2:
      sta  1984,x
      dex
      bpl  loopT2

; init the data of the x/y snake positions
initData:
      lda  #$30
      sta  SX_END+1               ; position to $30xx
      sta  SX_START+1
      lda  #$70
      sta  SY_END+1               ; position to $70xx
      sta  SY_START+1
      lda  #$00
      sta  SX_END
      sta  SY_END
      lda  #$02
      sta  SX_START
      sta  SY_START

insertSnake:                      ; insert the snake in the area
      ldx  #16
      ldy  #$00
      lda  #1
      sta  (SX_END),y
      txa
      sta  (SY_END),y
      sta  (SY_START),y
      lda  #3
      sta  (SX_START),y
      iny
      lda  #2
      sta  (SX_END),y
      txa
      sta  (SY_END),y

      ldy  #16
      ldx  #3
      jsr  SET_COOR               ; set x/y coord
      lda  #GREEN
      jsr  PUT_CHAR               ; color green for the snake

      lda  #SC_HEAD
      jsr  PUT_CHAR               ; put a char

      dex
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_SNAKE
      jsr  PUT_CHAR               ; put a char
      dex
      jsr  SET_COOR               ; set x/y coord
      lda  #SC_SNAKE
      jsr  PUT_CHAR               ; put a char

; insert a random block in the area
      lda  #BLUE
      jsr  PUT_CHAR               ; block is blue

      lda  54272+27               ; generate a random number of blocks
      and  #$07                   ; use 8 values
      adc  #$04

insertBlock:
      pha
      lda  54272+27               ; read a random number
      and  #$1F                   ; use 32 values
      adc  #$03                   ; compensate
      tay
      lda  54272+27
      and  #$0F                   ; use 16 values
      adc  #$05                   ; compensate
      tax

      jsr  SET_COOR
      lda  #SC_BORDER
      jsr  PUT_CHAR
      jsr  PUT_CHAR
      jsr  PUT_CHAR

      pla
      tax
      dex
      txa
      bne  insertBlock

                                  ; be sure to position the apple in the free

; init other variables
      lda  #$00
      sta  GO
      sta  GROWN
      sta  APPLE
      lda  #SPEED
      sta  TIMER
      ldx  #02
      stx  DIRECTION
      lda  #N_APPLE
      sta  MAX_APPLE

LocalLoop:                        ; loop for controlling the game
      lda  GO
      beq  LocalLoop
      dec  GO

; look for apple
      lda  APPLE
      bne  alreadyApple

      dec  MAX_APPLE
      bne  repeat
      jmp  youWin

; insert a random position apple
repeat:
      lda  54272+27               ; read a random number
      and  #$1F                   ; use 32 values
      adc  #$04                   ; compensate
      tay
      lda  54272+27
      and  #$0F                   ; use 16 values
      adc  #$04                   ; compensate
      tax

      jsr  SET_COOR
                                  ; be sure to position the apple in the free
      jsr  LINE
      lda  ($D1),y
      cmp  #32
      bne  repeat

      lda  #RED
      jsr  PUT_CHAR               ; color the apple in red

      lda  #SC_APPLE
      jsr  PUT_CHAR
                                  ; inset all the max apple
      inc  APPLE
      lda  APPLE
      cmp  MAX_APPLE
      bne  repeat

alreadyApple:

; move the head of the snake using direction
      ldx  #$00
      lda  (SY_START,x)
      tay
      lda  (SX_START,x)
      tax

; but first make the body onto the head
      jsr  SET_COOR
      lda  #GREEN
      jsr  PUT_CHAR               ; color the snake in green

      lda  #SC_SNAKE
      jsr  PUT_CHAR
                                  ; look for direction
      lda  #$01
      bit  DIRECTION
      beq  skipUp
      dex
skipUp:
      asl  a
      bit  DIRECTION
      beq  skipDn
      inx
skipDn:
      asl  a
      bit  DIRECTION
      beq  skipSx
      dey
skipSx:
      asl  a
      bit  DIRECTION
      beq  skipDx
      iny
skipDx:
      jsr  SET_COOR
                                  ; read the char in the position to go
      jsr  LINE
      lda  ($D1),y

      cmp  #SP_BORDER              ; goto border ?
      beq  Died
      cmp  #SP_SNAKE               ; goto snake ?
      beq  Died
      cmp  #SP_APPLE
      bne  redrawSnake

      lda  #N_GROWN
      sta  GROWN
      dec  APPLE

redrawSnake:
                                  ; make the snake haed
      lda  #SC_HEAD
      jsr  PUT_CHAR
                                  ; update pointers
      inc  SX_START
      inc  SY_START
      bne  skipIncS
      inc  SX_START+1
      inc  SY_START+1
skipIncS:
      txa
      ldx  #$00
      sta  (SX_START,x)
      tya
      sta  (SY_START,x)

      lda  GROWN
      beq  removeEnd

      dec  GROWN
      jmp  LocalLoop

; remove the end of the snake
removeEnd:
      ldx  #$00
      lda  (SY_END,x)
      tay
      lda  (SX_END,x)
      tax
      jsr  SET_COOR               ; set x/y coord
      lda  #32
      jsr  PUT_CHAR
                                  ; increment pointers
      inc  SX_END
      inc  SY_END
      bne  skipInc
      inc  SX_END+1
      inc  SY_END+1
skipInc:
      jmp  LocalLoop

Died:
      jmp  MainLoop

youWin:
      jsr  SCREEN
      lda  #<Swin
      ldy  #>Swin
      jsr  $AB1E                    ; write a string
loopDelay:
      jsr  $EEB3                    ; ciclo ritardo
      jsr  $EEB3                    ; ciclo ritardo
      dex
      bne  loopDelay
      jmp  MainLoop

; interrupt routine
irqR:
      php
      pha
      dec  TIMER
      bne  jumpIRQ
      inc  GO
      lda  #SPEED
      sta  TIMER

jumpIRQ:
      ; look for direction
      lda  $DC01
      eor  #$FF
      sta  TEMP

      lda  #$01                   ; test for up
      bit  TEMP
      bne  setting
notUp:
      asl  a                      ; test for dn
      bit  TEMP
      bne  setting
notDn:
      asl  a
      bit  TEMP
      bne  setting
notSx:
      asl  a
      bit  TEMP
      beq  notSetting
notDx:
setting:
      sta  DIRECTION
notSetting:
      pla
      plp
      jmp  $EA32

Swin:
  .byte "WIN!", 0
